//+------------------------------------------------------------------+
//|                                                      Pearson.mq5 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#include <MovingAverages.mqh>

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_plots   1

#property indicator_type1   DRAW_LINE
#property indicator_color1  clrDarkViolet
#property indicator_style1  STYLE_SOLID

input int DPperiod   =15;
input int CorrPeriod = 15;
double m[];
double Pearson[];
int begin1;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   SetIndexBuffer(0,Pearson,INDICATOR_DATA);
   SetIndexBuffer(1,m,INDICATOR_CALCULATIONS);
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+10);
   begin1=DPperiod-1;
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
   int i,limit;
   double sMN,x,xKV,y,yKV,Q;
   if(prev_calculated==0){limit=DPperiod+2*CorrPeriod+1;}
   else
     {limit=prev_calculated-1;}
//---
   ExponentialMAOnBuffer(rates_total,prev_calculated,begin1,DPperiod,open,m);
   for(i=limit;i<rates_total;i++)
     {
      sMN=0.0;
      x=0.0;
      y=0.0;
      xKV=0.0;
      yKV=0.0;
      for(int k=i;k>i-CorrPeriod;k--)
        {
         x=open[k]-open[i];
         y=m[k]-m[i];
         sMN=sMN+(x*y);
         xKV=xKV+(x*x);
         yKV=yKV+(y*y);
        }
      Q=MathSqrt(xKV*yKV);
      if(Q!=0.0)Pearson[i]=sMN/Q;
     }
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
